using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SubSystems.TE;
using SubSystems.HT;
using Keyoti.RapidSpell;

namespace RapidTernTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        string strText;
        string strHtml;
        private void Form1_Load(object sender, EventArgs e)
        {
            this.rapidSpellAsYouType1.TextComponent = txtBody;
            this.rapidSpellAsYouType1.CheckAsYouType = false;
        }

        private void btLoadText_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofdInsertText = new OpenFileDialog();
            if (ofdInsertText.ShowDialog() == DialogResult.OK)
            {
                if (ofdInsertText.FileName != "")
                {
                    System.IO.StreamReader srTextFile = new System.IO.StreamReader(ofdInsertText.FileName);
                    strText = "";
                    // Read and display lines from the file until the end of 
                    // the file is reached.
                    string strLine;
                    while ((strLine = srTextFile.ReadLine()) != null)
                    {
                        strText += strLine + "\r\n";
                    }

                }
            }
        }

        private void btLoadHtml_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofdInsertText = new OpenFileDialog();
            if (ofdInsertText.ShowDialog() == DialogResult.OK)
            {
                if (ofdInsertText.FileName != "")
                {
                    System.IO.StreamReader srTextFile = new System.IO.StreamReader(ofdInsertText.FileName);
                    strHtml = "";
                    // Read and display lines from the file until the end of 
                    // the file is reached.
                    string strLine;
                    while ((strLine = srTextFile.ReadLine()) != null)
                    {
                        strHtml += strLine + "\r\n";
                    }

                }
            }
        }

        private void btShowText_Click(object sender, EventArgs e)
        {
            //if (rapidSpellAsYouType1.CheckAsYouType == true)
            //{
            //    rapidSpellAsYouType1.CheckAsYouType = false;
            //    rapidSpellAsYouType1.CheckAsYouType = true;
            //}
            txtBody.Data = strText;
        }

        private void btShowHtml_Click(object sender, EventArgs e)
        {
            //if (rapidSpellAsYouType1.CheckAsYouType == true)
            //{
            //    rapidSpellAsYouType1.CheckAsYouType = false;
            //    rapidSpellAsYouType1.CheckAsYouType = true;
            //}
            txtBody.TerSetFlags4(true, SubSystems.TE.tc.TFLAG4_HTML_INPUT);
            txtBody.Data = strHtml;
            txtBody.TerSetFlags4(false, SubSystems.TE.tc.TFLAG4_HTML_INPUT);
        }

        private void rapidSpellCheck_CheckStateChanged(object sender, EventArgs e)
        {
            if (rapidSpellCheck.Checked == true)
            { 
                rapidSpellAsYouType1.CheckAsYouType = true;
            }
            else if (rapidSpellCheck.Checked == false)
            { 
                rapidSpellAsYouType1.CheckAsYouType = false;;
            }
        }

        private void rapidSpellCheck_CheckedChanged(object sender, EventArgs e)
        {

        }
    }
}