﻿Imports System.Collections.Generic
Imports System.Text
Imports System.Windows.Forms
Imports System.Drawing
Imports SubSystems.TE
Imports SubSystems.HT
Imports Keyoti.RapidSpell
Imports System.Threading

Namespace RapidTernTest
    Public Class AYTTern
        Inherits Tern
        Implements ISpellCheckableTextComponent
        Implements IAYTTextBox

        Private _cmsPopupMenu As ContextMenuStrip
        Private tbu As CustomTextBoxUtilityAdapter
        Public Property cmsPopupMenu() As ContextMenuStrip
            Get
                Return _cmsPopupMenu
            End Get
            Set(value As ContextMenuStrip)
                _cmsPopupMenu = value
            End Set
        End Property
        Public Property HtmlObject() As Htn
            Get
                Return _HtmlObject
            End Get
            Set(value As Htn)
                _HtmlObject = value
            End Set
        End Property
        Public Event Enter1(ByVal sender As Object, ByVal e As System.EventArgs) Implements IAYTTextBox.Enter

        Private Sub BaseTextBoxMaskBox_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Enter
            RaiseEvent Enter1(sender, e)
        End Sub

        Public ReadOnly Property Handle1() As System.IntPtr Implements IAYTTextBox.Handle
            Get
                Return Handle
            End Get
        End Property


        Public Overloads Function BeginInvoke1(ByVal d As System.Delegate) As System.IAsyncResult Implements IAYTTextBox.BeginInvoke
            Return MyBase.BeginInvoke(d)
        End Function

        Public Overloads Function BeginInvoke2(ByVal d As System.Delegate, ByVal parameters() As Object) As System.IAsyncResult Implements IAYTTextBox.BeginInvoke
            Return MyBase.BeginInvoke(d, parameters)
        End Function

        Public Sub SuspendLayout1() Implements IAYTTextBox.SuspendLayout
            SuspendLayout()

        End Sub

        Public Property Height1() As Integer Implements IAYTTextBox.Height
            Get
                Return Height
            End Get
            Set(ByVal Value As Integer)
                Height = Value
            End Set
        End Property


        Public Overrides Property ContextMenu() As ContextMenu Implements IAYTTextBox.ContextMenu
            Get
                Return MyBase.ContextMenu
            End Get
            Set(ByVal Value As ContextMenu)
                If (MyBase.ContextMenu Is Nothing) Then
                    MyBase.ContextMenu = Value
                End If
            End Set
        End Property
        Public Overrides Property ContextMenuStrip() As ContextMenuStrip Implements IAYTTextBox.ContextMenuStrip
            Get
                Return MyBase.ContextMenuStrip
            End Get
            Set(ByVal Value As ContextMenuStrip)

                MyBase.ContextMenuStrip = Value

            End Set
        End Property

        Public Sub Refresh1() Implements IAYTTextBox.Refresh
            If InvokeRequired Then
                Invoke(New ThreadStart(AddressOf Refresh))
            Else
                Refresh()
            End If

        End Sub

        Public Property Width1() As Integer Implements IAYTTextBox.Width
            Get
                Return Width
            End Get
            Set(ByVal Value As Integer)
                Width = Value
            End Set
        End Property

        Public Property Size1() As Size Implements IAYTTextBox.ClientSize
            Get
                Return ClientSize
            End Get
            Set(ByVal Value As Size)
                ClientSize = Value
            End Set
        End Property


        Private _tsmiCopy As ToolStripMenuItem
        Private _tsmiPaste As ToolStripMenuItem
        Private _tsmiCut As ToolStripMenuItem
        Private _tsmiSelectAll As ToolStripMenuItem
        Private _tsmiUndo As ToolStripMenuItem
        Private _tsmiDelete As ToolStripMenuItem
        Private _tssFirstSeparator As ToolStripSeparator
        Private _tssSecondSeparator As ToolStripSeparator
        Private _blHtmlEdit As Boolean = False
        Private _HtmlObject As Htn
        Public Sub setHtmlObject()
            _HtmlObject = New Htn(Me)
        End Sub

        Public Sub MyDispose() Implements ISpellCheckableTextComponent.Dispose
            MyBase.Dispose()
        End Sub
        Public ReadOnly Property MyIsDisposed() As Boolean Implements IAYTTextBox.IsDisposed
            Get
                Return MyBase.IsDisposed
            End Get

        End Property

        Public ReadOnly Property MyIsDisposing() As Boolean Implements IAYTTextBox.Disposing
            Get
                Return MyBase.Disposing
            End Get

        End Property

        Public ReadOnly Property MyIsHandleCreated() As Boolean Implements IAYTTextBox.IsHandleCreated
            Get
                Return MyBase.IsHandleCreated
            End Get

        End Property
        Public ReadOnly Property MyRecreatingHandle() As Boolean Implements IAYTTextBox.RecreatingHandle
            Get
                Return MyBase.RecreatingHandle
            End Get

        End Property

        Public ReadOnly Property MyParent() As Control Implements IAYTTextBox.Parent
            Get
                Return MyBase.Parent
            End Get

        End Property

        Public Sub New()
            _HtmlObject = New Htn(Me)

            _cmsPopupMenu = New ContextMenuStrip()
            AddHandler _cmsPopupMenu.Opening, New System.ComponentModel.CancelEventHandler(AddressOf _cmsPopupMenu_Opening)

            _tsmiUndo = New ToolStripMenuItem()
            _tsmiUndo.Text = "Undo"
            AddHandler _tsmiUndo.Click, New EventHandler(AddressOf _tsmiUndo_Click)
            _cmsPopupMenu.Items.Add(_tsmiUndo)

            _tssFirstSeparator = New ToolStripSeparator()
            _cmsPopupMenu.Items.Add(_tssFirstSeparator)

            _tsmiCut = New ToolStripMenuItem()
            _tsmiCut.Text = "Cut"
            AddHandler _tsmiCut.Click, New EventHandler(AddressOf _tsmiCut_Click)
            _cmsPopupMenu.Items.Add(_tsmiCut)

            _tsmiCopy = New ToolStripMenuItem()
            _tsmiCopy.Text = "Copy"
            AddHandler _tsmiCopy.Click, New EventHandler(AddressOf _tsmiCopy_Click)
            _cmsPopupMenu.Items.Add(_tsmiCopy)

            _tsmiPaste = New ToolStripMenuItem()
            _tsmiPaste.Text = "Paste"
            AddHandler _tsmiPaste.Click, New EventHandler(AddressOf _tsmiPaste_Click)
            _cmsPopupMenu.Items.Add(_tsmiPaste)

            _tsmiDelete = New ToolStripMenuItem()
            _tsmiDelete.Text = "Delete"
            AddHandler _tsmiDelete.Click, New EventHandler(AddressOf _tsmiDelete_Click)
            _cmsPopupMenu.Items.Add(_tsmiDelete)

            _tssSecondSeparator = New ToolStripSeparator()
            _cmsPopupMenu.Items.Add(_tssSecondSeparator)

            _tsmiSelectAll = New ToolStripMenuItem()
            _tsmiSelectAll.Text = "Select All"
            AddHandler _tsmiSelectAll.Click, New EventHandler(AddressOf _tsmiSelectAll_Click)
            _cmsPopupMenu.Items.Add(_tsmiSelectAll)
            ContextMenuStrip = _cmsPopupMenu
            Me.VertScrollBar = True
            Me.HorzScrollBar = True
            Me.BorderMargin = False

            TerCommand(tc.ID_FITTED_VIEW)
            TerSetFlags4(True, tc.TFLAG4_ONE_ROW_TOOLBAR)
            TerRecreateToolbar(False)
            ShowStatusBar = False
            AddHandler Action, AddressOf AdvancedTxTextControl_Action
            AddHandler PostPaint, AddressOf AdvancedTxTextControl_PostPaint
            AddHandler Paint, AddressOf AdvancedTxTextControl_Paint
        End Sub

        Private Sub AdvancedTxTextControl_PostPaint(Sender As Object, gr As Graphics)
            RaiseEvent ControlPaint(Sender, New EventArgs())
        End Sub

        Private Sub AdvancedTxTextControl_Action(Sender As Object, ActionType As Integer, ActionId As Integer)
            Dim e As New EventArgs()
            If ActionType = tc.ACTION_HSCROLL Then
                RaiseEvent HScrolled(Sender, e)
            ElseIf ActionType = tc.ACTION_VSCROLL Then
                RaiseEvent VScrolled(Sender, e)
            ElseIf ActionType = tc.ACTION_STYLE Then

                RaiseEvent FormatChanged(Sender, e)

            ElseIf ActionType = tc.ACTION_COMMAND Then
                Select Case ActionId
                    Case tc.ID_UP
                        RaiseEvent VScrolled(Sender, e)
                        Exit Select
                    Case tc.ID_DOWN
                        RaiseEvent VScrolled(Sender, e)
                        Exit Select
                    Case tc.ID_DEL
                        OnTextChanged(e)
                        Exit Select
                    Case tc.ID_BACK_SPACE
                        OnTextChanged(e)
                        Exit Select
                    Case tc.ID_REPLACE
                        OnTextChanged(e)
                        Exit Select
                    Case tc.ID_RETURN
                        Console.WriteLine("ID_RETURN")
                        OnTextChanged(e)
                        Exit Select
                End Select
            End If
            If ActionType = tc.ACTION_CHAR Then
                If ActionId = 32 Then
                    OnTextChanged(e)
                End If
            End If

            If ActionType <> 5 AndAlso ActionType <> 7 AndAlso ActionType <> 9 AndAlso ActionType <> 14 AndAlso ActionType <> 6 AndAlso ActionType <> 8 AndAlso ActionType <> 10 Then

                OnTextChanged(EventArgs.Empty)
            End If
        End Sub

        Private Sub AdvancedTxTextControl_Paint(sender As Object, e As PaintEventArgs)
            RaiseEvent ControlPaint(sender, New EventArgs())
        End Sub


        Private Sub _tsmiUndo_Click(sender As Object, e As EventArgs)
            TerCommand(tc.ID_UNDO)
        End Sub

        Private Sub _tsmiCut_Click(sender As Object, e As EventArgs)
            TerCommand(tc.ID_CUT)
        End Sub

        Private Sub _tsmiCopy_Click(sender As Object, e As EventArgs)
            TerCommand(tc.ID_COPY)
        End Sub

        Private Sub _cmsPopupMenu_Opening(sender As Object, e As System.ComponentModel.CancelEventArgs)
            _tsmiDelete.Enabled = True
            _tsmiCut.Enabled = True
            _tsmiPaste.Enabled = True
            _tsmiUndo.Enabled = True

            If ReadOnlyMode Then
                _tsmiDelete.Enabled = False
                _tsmiCut.Enabled = False
                _tsmiPaste.Enabled = False
                _tsmiUndo.Enabled = False
            End If
        End Sub

        Private Sub _tsmiSelectAll_Click(sender As Object, e As EventArgs)
            TerCommand(tc.ID_SELECT_ALL)
        End Sub

        Private Sub _tsmiDelete_Click(sender As Object, e As EventArgs)
            TerCommand(tc.ID_CUT)
            Clipboard.Clear()
        End Sub

        Private Sub _tsmiPaste_Click(sender As Object, e As EventArgs)
            TerCommand(tc.ID_PASTE)
        End Sub


        Public Overrides Property Text() As String Implements ISpellCheckableTextComponent.Text, IAYTTextBox.Text
            Get

                Me.TerSetOutputFormat(SubSystems.TE.tc.SAVE_TEXT)
                Dim text__1 As String = Me.Data.Replace(vbCr, "")
                Me.TerSetOutputFormat(SubSystems.TE.tc.SAVE_DEFAULT)

                'this.TerCommand(tc.ID_SELECT_ALL);
                'string text = this.TerGetTextSel();
                'this.DeselectTerText(true);
                text__1 = If((text__1 Is Nothing), String.Empty, text__1)
                'System.Diagnostics.Debug.WriteLine(text.Length);
                Return text__1
            End Get
            Set(value As String)
                MyBase.Text = value
            End Set
        End Property


        Private bHideSelection As Boolean

        Public Property HideSelection() As Boolean Implements ISpellCheckableTextComponent.HideSelection
            Get
                Return bHideSelection
            End Get
            'isn't used in TE. It's either painted when an action is performed or not.
            Set(value As Boolean)
                bHideSelection = value
                Me.DeselectTerText(True)
            End Set
        End Property

        Public ReadOnly Property [ReadOnly]() As Boolean Implements IAYTTextBox.ReadOnly, ISpellCheckableTextComponent.ReadOnly
            Get
                Return MyBase.ReadOnlyMode
            End Get
        End Property

        Public Shadows ReadOnly Property Enabled() As Boolean Implements IAYTTextBox.Enabled, ISpellCheckableTextComponent.Enabled
            Get
                Return MyBase.Enabled
            End Get
        End Property

        Public Sub ScrollToCaret() Implements ISpellCheckableTextComponent.ScrollToCaret
            'System.Diagnostics.Debug.WriteLine(" scroll to Caret = " + TerGetTextSel());
            Me.TerSearchReplace2(TerGetTextSel(), "", tc.SRCH_SEARCH + tc.SRCH_SCROLL, SelectionStart, 0)
            'this.TerEngageCaret(false);
        End Sub

        Public Property SelectedText() As String Implements IAYTTextBox.SelectedText, ISpellCheckableTextComponent.SelectedText
            Get
                'System.Diagnostics.Debug.WriteLine(this.TerGetTextSel());
                Return Me.TerGetTextSel()
            End Get
            Set(value As String)
                Me.TerDeleteBlock(False)
                Me.InsertTerText(value, True)
            End Set
        End Property

        Public Property SelectionLength() As Integer Implements IAYTTextBox.SelectionLength, ISpellCheckableTextComponent.SelectionLength
            Get
                'System.Diagnostics.Debug.WriteLine("get Selected Text = " + this.TerGetTextSel());
                Return If(Me.TerGetTextSel() IsNot Nothing, Me.TerGetTextSel().Length, 0)
            End Get
            Set(value As Integer)
                'diag debug to figure out the call order of the interface.
                'System.Diagnostics.Debug.WriteLine("set SelectionLength = " + value.ToString());
                Dim line As Integer, col As Integer, endline As Integer, endcol As Integer
                Dim absstart As Integer = Me.SelectionStart
                Dim absend As Integer = Me.SelectionStart + value
                Me.TerAbsToRowCol(absend, endline, endcol)
                Me.TerAbsToRowCol(absstart, line, col)
                Me.SelectTerText(line, col, endline, endcol, True)
            End Set
        End Property

        Public Property SelectionStart() As Integer Implements IAYTTextBox.SelectionStart, ISpellCheckableTextComponent.SelectionStart
            Get
                Dim line As Integer, col As Integer
                line = Me.TerGetParam(tc.TP_SELECTION_START_LINE)
                col = Me.TerGetParam(tc.TP_SELECTION_START_COL)

                Dim ix As Integer = Me.TerRowColToAbs(line, col)

                'diag debug to figure out the call order of the interface.
                'System.Diagnostics.Debug.WriteLine("get SelectionStart = " + ix.ToString()); 
                Return ix
            End Get
            Set(value As Integer)
                'diag debug to figure out the call order of the interface.
                'System.Diagnostics.Debug.WriteLine("set SelectionStart = " + value.ToString());

                Dim line As Integer, col As Integer, endline As Integer, endcol As Integer
                Dim absstart As Integer = value
                Dim absend As Integer = value
                Me.TerAbsToRowCol(absend, endline, endcol)
                Me.TerAbsToRowCol(absstart, line, col)
                Me.SelectTerText(line, col, endline, endcol, True)
            End Set
        End Property


        Public Event KeyDown1(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Implements IAYTTextBox.KeyDown
        Public Event KeyPress1(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Implements IAYTTextBox.KeyPress

        Public Event KeyUp1(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Implements IAYTTextBox.KeyUp

        Public Event Leave1(ByVal sender As Object, ByVal e As System.EventArgs) Implements IAYTTextBox.Leave


        Public Event MouseDown1(ByVal sender As Object, ByVal e As MouseEventArgs) Implements IAYTTextBox.MouseDown
        Public Event MouseUp1(ByVal sender As Object, ByVal e As MouseEventArgs) Implements IAYTTextBox.MouseUp
        Public Event MouseWheel1(ByVal sender As Object, ByVal e As MouseEventArgs) Implements IAYTTextBox.MouseWheel


        Private Sub BaseTextBoxMaskBox_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
            RaiseEvent KeyDown1(sender, e)
        End Sub

        Private Sub BaseTextBoxMaskBox_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
            RaiseEvent KeyUp1(sender, e)
        End Sub


        Private Sub BaseTextBoxMaskBox_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Leave
            RaiseEvent Leave1(sender, e)
        End Sub


        Private Sub BaseTextBoxMaskBox_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
            RaiseEvent MouseDown1(sender, e)
        End Sub


        Private Sub BaseTextBoxMaskBox_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
            RaiseEvent MouseUp1(sender, e)
        End Sub


        Private Sub BaseTextBoxMaskBox_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseWheel
            RaiseEvent MouseWheel1(sender, e)
        End Sub

        Private Sub BaseTextBoxMaskBox_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
            RaiseEvent Resize1(sender, e)
        End Sub


        Private Sub BaseTextBoxMaskBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.TextChanged
            RaiseEvent TextChanged1(sender, e)
        End Sub

        Public Event TextChanged1(ByVal sender As Object, ByVal e As System.EventArgs) Implements IAYTTextBox.TextChanged
        Public Event Resize1(ByVal sender As Object, ByVal e As System.EventArgs) Implements IAYTTextBox.Resize


        Public Event VScrolled As EventHandler Implements IAYTTextBox.VScrolled
        Public Event VScrollEnd As EventHandler Implements IAYTTextBox.VScrollEnd
        Public Event HScrolled As EventHandler Implements IAYTTextBox.HScrolled
        Public Event ControlPaint As EventHandler Implements IAYTTextBox.ControlPaint
        Public Event FormatChanged As EventHandler Implements IAYTTextBox.FormatChanged
        Public Event ScrollCaret As EventHandler Implements IAYTTextBox.ScrollCaret
        Public Event MyDisposed As EventHandler Implements IAYTTextBox.Disposed, ISpellCheckableTextComponent.Disposed
        Public Event MyGotFocus As EventHandler Implements ISpellCheckableTextComponent.GotFocus

        Private Sub RethrowDisposed() Handles MyBase.Disposed
            RaiseEvent MyDisposed(Me, EventArgs.Empty)
        End Sub

        Private Sub RethrowMyGotFocus() Handles MyBase.GotFocus
            RaiseEvent MyGotFocus(Me, EventArgs.Empty)
        End Sub

        Public Function GetLineFromCharIndex(intCharIndex As Integer) As Integer Implements IAYTTextBox.GetLineFromCharIndex
            Dim line As Integer, col As Integer
            Me.TerAbsToRowCol(intCharIndex, line, col)
            'System.Diagnostics.Debug.WriteLine("GetLineFromCharIndex: " + line);
            Return line
        End Function
        Public Function GetCharIndexFromPos(pontXY As System.Drawing.Point) As Integer Implements IAYTTextBox.GetCharIndexFromPos
            Dim line As Integer
            Dim col As Integer = -1
            ' set to 0 to retrieve the position in line/column format.
            Me.TerPixToTextPos(tc.REL_WINDOW, pontXY.X, pontXY.Y, line, col)

            'System.Diagnostics.Debug.WriteLine("GetCharIndexFromPos: " + this.TerRowColToAbs(line, col));

            Return Me.TerRowColToAbs(line, col)
        End Function
        Public Function GetPosFromCharIndex(intCharIndex As Integer) As Point Implements IAYTTextBox.GetPosFromCharIndex
            Dim x As Integer, y As Integer
            Me.TerTextPosToPix(tc.REL_WINDOW, intCharIndex, -1, x, y)

            'System.Diagnostics.Debug.WriteLine("GetPosFromCharIndex Char Index: " + intCharIndex);
            'System.Diagnostics.Debug.WriteLine("GetPosFromCharIndex: " + x.ToString() + " " + y.ToString());
            Return New Point(x, y)
        End Function
        Public Function GetFirstVisibleCharIndex() As Integer Implements IAYTTextBox.GetFirstVisibleCharIndex

            Return 0
        End Function

        Public Function GetTBU() As Keyoti.RapidSpell.TextBoxUtilityAdapter Implements IAYTTextBox.GetTBU
            If tbu Is Nothing OrElse tbu.IsFinished Then
                tbu = New CustomTextBoxUtilityAdapter(Me)
            End If
            Return tbu
        End Function

        Public Property _tbu() As CustomTextBoxUtilityAdapter
            Get
                Return tbu
            End Get
            Set(value As CustomTextBoxUtilityAdapter)
                tbu = value
            End Set
        End Property
        Public ReadOnly Property ContextMenuStripDefault() As ContextMenuStrip Implements IAYTTextBox.ContextMenuStripDefault
            Get
                Return Nothing
            End Get
        End Property
        Public ReadOnly Property ContextMenuDefault() As ContextMenu Implements IAYTTextBox.ContextMenuDefault
            Get
                Return Nothing
            End Get
        End Property
        Public ReadOnly Property DefaultContextMenu() As ContextMenu Implements IAYTTextBox.DefaultContextMenu
            Get
                Return Nothing
            End Get
        End Property

        Public ReadOnly Property TextLength() As Integer Implements IAYTTextBox.TextLength
            Get
                'System.Diagnostics.Debug.WriteLine("Text Length: " + Text.Length);
                Return Text.Length
            End Get
        End Property
        Public Function GetBaselineOffsetAtCharIndex(intCharIndex As Integer) As Integer Implements IAYTTextBox.GetBaselineOffsetAtCharIndex
            Return TerScrLineHeight(GetLineFromCharIndex(intCharIndex))
        End Function

    End Class
    Public Class CustomTextBoxUtilityAdapter
        Inherits TextBoxUtilityAdapter
        Public Sub New(advText As AYTTern)
            MyBase.New(advText)
        End Sub
    End Class
End Namespace